
sub usage {
    die("usage: $0 <toolname-main-file>");
}

if ($#ARGV != 1) {
    &usage;
}

$mainfile = $ARGV[0];
$toolname = $ARGV[1];
open(OF, ">$toolname");
print "expanding $mainfile to $toolname ... \n";

# print header
open(H, "head.tcl");
while (<H>) {
    s/TOOLNAME/$toolname/;
    print OF;
}
close(H);

$tclsh = $ENV{'TCLSH'};
open(S, "$tclsh tcl-expand.tcl $mainfile |");

line:
while (<S>) {
    if (/^\s*$/) { 
	next line; 
    }
    # note that comment lines followed by \ will not work
    if (/^\s*#/) {		
	next line;
    }
    print OF;
    $n++;
    ($n % 500 == 0) && print("*");
}

print "\ntotal $n lines\n";
close(S);
close(OF);

# # now generate the batch file
# open(BF, ">$toolname.bat");
# print BF "\@echo off\n";
# print BF "REM get all args into %ARGS%\n";
# print BF "set ARGS=%1\n";
# print BF ":again\n";
# print BF "shift\n";
# print BF "set ARGS=%ARGS% %1\n";
# print BF "if not !%1==%! goto again\n";
# print BF "start mash $tool -name $tool -- %ARGS%\n";
# close(BF);;
# print "created $tool.bat\n";
