#ifndef mc_session_h
#define mc_session_h

#include "srm/session-srm.h"

class MC_Pending;

/*
 * So that we can have a "REPLY PENDING" message. 
 */
class MC_Session : public SRM_Session {
public:
	/* 
	 * Trying anything with these parameters; currently, 
	 * they are d1 & d2 shifted right by 1. min_pending_ is
	 * set equal to min_reply_.
	 */
	MC_Session(void) : e1_(2), e2_(3), min_pending_(100) {}
	void sched_pending(MC_Pending *mp, const srm_src& ss);
protected:
	float e1_;
	float e2_;
	short min_pending_;
	double pending_time(const srm_src& rpy_tgt);
};

#endif // mc_session_h
