/*
 * Copyright (c) 1992 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef wb_proc_h
#define wb_proc_h

class Process {
public:
	Process();
	~Process();
	void fork(const char* exec, int argc = 0, char** argv = 0);
	void kill();
	void nonblock(int fd);
	inline int readfd() { return (fd_in); }
	inline int writefd() { return (fd_out); }
	inline int errorfd() { return (fd_err); }
	void setenv(const char* var, const char* value);
	const char* getenv(const char* var);
private:
	int envslot(const char* var);
	int fd_in;
	int fd_err;
	int fd_out;
	char** environ;
	int envbase;
	int nenv;
	int maxenv;
	int pid;
};

#endif
