/*
 * Copyright (c) 1992 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: /usr/src/mash/repository/mash/mash-1/ps/ps.h,v 1.3 1997/08/09 03:58:20 tecklee Exp $ (LBL)
 */

#ifndef mash_ps_h
#define mash_ps_h

#include "tclcl.h"
#ifndef WIN32
#   include <sys/param.h>
#endif
#include <X11/Xlib.h>

class PSstream;
class DrawOpPSComp;
class View;
class Raster;

class PSinterp : public TclObject {
    public:
	PSinterp();
	virtual ~PSinterp();
	virtual int send(DrawOpPSComp*, View*, PSstream*);
	virtual int busy();
	virtual void interp_page(Window msgwin);
	virtual void interp_done(Window msgwin);
    protected:
	Raster* raster_;
	PSstream* strm_;
	DrawOpPSComp* op_;
	View* view_;
	float scale_;
	char* tmpfile_;
	int tmpfd_;
};

#endif
