#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "srmv2.h"
#include "rreq-srmv2.h"

SRMv2_RReq::SRMv2_RReq(unsigned int ss, unsigned int es, unsigned int cid,
		   unsigned int sbytes, unsigned int ebytes) :
	Timer(), ss_(ss), es_(es), sbytes_(sbytes), 
	ebytes_(ebytes), cid_(cid)
{ }

SRMv2_RReq::~SRMv2_RReq() 
{ 
	printf("cancelling (%d %d %d)\n", cid_, sbytes_, ebytes_);
	cancel();
}

void
SRMv2_RReq::sched_timeout(int ms, SRMv2_Session *session, SRMv2_Source *src) 
{
	msec_ = ms;
	if (session) 
		session_ = session;
	source_ = src;
	printf("[sched_timeo] : %dms (%d %d %d %d %d)\n", msec_, cid_, ss_, es_, sbytes_, ebytes_);
	msched(ms);
}


void 
SRMv2_RReq::timeout() 
{
	/* Change this to traverse the list and stack RREQs */
//	for (int i = 0; i < 4; i ++)
//		printf("%d ", source_->source_id(i));
	printf("S: %dms %d %d %d %d %d\n", msec_, cid_, ss_, es_, sbytes_, ebytes_);
	session_->send_rreq(source_, ss_, es_, sbytes_, ebytes_, cid_);
	msec_ *= 2; // Exponential backoff
	sched_timeout(msec_, 0, source_);
}



