

import Application ScopeZone SDPParser SAPAnnouncer Program

# 
Class SDAnnouncerApplication -superclass Application

#
SDAnnouncerApplication public init argv {
    $self next sdannouncer

    set o [$self options]
    set args [$o parse_args $argv]

    set l [llength $args]
    if {$l<1 || $l>2} {
	$self usage
	exit 1
    }

    eval $self init_announcer $args
}

#
SDAnnouncerApplication private init_announcer {file {range "224.2.128.0/17"}} {
    $self instvar scope_ announcer_

    set scope_ [new ScopeZone $range]
    set announcer_ [new SAPAnnouncer $scope_]

    if [catch {set fp [open $file r]} m] {
	$self fatal "Cannot open file $file: $m"
    }
    set sdp [read $fp]
    close $fp

    set p [new SDPParser]
    set msg [$p parse $sdp]
    if {$msg == ""} {
	$self fatal "SDP Parser Error: [$p parse_error]"
    }
    delete $p

    set prog [new Program $msg]

    $announcer_ addprog $self $prog
}

new SDAnnouncerApplication $argv
vwait forever
